/*
 * Created on 2005-1-25
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.example.parts;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import org.eclipse.draw2d.AbsoluteBendpoint;
import org.eclipse.draw2d.BendpointConnectionRouter;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.graph.DirectedGraph;
import org.eclipse.draw2d.graph.Edge;
import org.eclipse.draw2d.graph.Node;
import org.eclipse.draw2d.graph.NodeList;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editparts.AbstractConnectionEditPart;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

import com.example.policies.ConnectionEditPolicy;

/**
 * @author zhanghao
 *
 */
public class ConnectionPart extends AbstractConnectionEditPart {

    protected IFigure createFigure() {
        PolylineConnection conn = new PolylineConnection();
        conn.setTargetDecoration(new PolygonDecoration());
        conn.setConnectionRouter(new BendpointConnectionRouter());
        return conn;
    }

    protected void createEditPolicies() {
        installEditPolicy(EditPolicy.COMPONENT_ROLE, new ConnectionEditPolicy());
        installEditPolicy(EditPolicy.CONNECTION_ENDPOINTS_ROLE, new ConnectionEndpointEditPolicy());
    }

    protected void refreshVisuals() {
    }

    public void setSelected(int value) {
        super.setSelected(value);
        if (value != EditPart.SELECTED_NONE)
            ((PolylineConnection) getFigure()).setLineWidth(2);
        else
            ((PolylineConnection) getFigure()).setLineWidth(1);
    }
 
    /**
     * ʹƹͼԪ
     * @param graph
     * @param map
     */
    protected void applyGraphResults(DirectedGraph graph, Map map) {
    	Edge e = (Edge)map.get(this);
    	NodeList nodes = e.vNodes;
    	PolylineConnection conn = (PolylineConnection)getConnectionFigure();
    	conn.setTargetDecoration(new PolygonDecoration());
    	if (nodes != null) {
    		List bends = new ArrayList();
    		for (int i = 0; i < nodes.size(); i++) {
    			Node vn = nodes.getNode(i);
    			int x = vn.x;
    			int y = vn.y;
    			if (e.isFeedback) {
    				bends.add(new AbsoluteBendpoint(x, y + vn.height));
    				bends.add(new AbsoluteBendpoint(x, y));
    			} else {
    				bends.add(new AbsoluteBendpoint(x, y));
    				bends.add(new AbsoluteBendpoint(x, y + vn.height));
    			}
    		}
    		conn.setRoutingConstraint(bends);
    	} else {
    		conn.setRoutingConstraint(Collections.EMPTY_LIST);
    	}
    }

}