/*
 * Created on 2005-1-24
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.example.parts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;
import java.util.Map;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.FreeformLayer;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LayoutManager;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.draw2d.graph.DirectedGraph;
import org.eclipse.draw2d.graph.Edge;
import org.eclipse.draw2d.graph.Node;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;

import com.example.model.Diagram;
import com.example.policies.DiagramLayoutEditPolicy;

/**
 * @author zhanghao
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DiagramPart extends AbstractGraphicalEditPart implements PropertyChangeListener {

	protected List getModelChildren() {
		return ((Diagram) this.getModel()).getNodes();
	}

	public void activate() {
		super.activate();
		((Diagram) getModel()).addPropertyChangeListener(this);
	}

	public void deactivate() {
		super.deactivate();
		((Diagram) getModel()).removePropertyChangeListener(this);
	}

	public void propertyChange(PropertyChangeEvent evt) {
		String prop = evt.getPropertyName();
		if (Diagram.PROP_NODE.equals(prop))
			refreshChildren();
		if (Diagram.PROP_LAYOUT.equals(prop)) {
			refreshVisuals();
		}
	}

	LayoutManager graphLayout = new GraphLayoutManager(this);

	LayoutManager freeformLayout = new FreeformLayout();

	protected void refreshVisuals() {
		Diagram diagram = (Diagram) getModel();
		if (diagram.isAutoLayout()) {
			getFigure().setLayoutManager(graphLayout);
		} else {
			getFigure().setLayoutManager(freeformLayout);
		}
	}

	protected IFigure createFigure() {
		Figure figure = new FreeformLayer();
		return figure;
	}

	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.LAYOUT_ROLE, new DiagramLayoutEditPolicy());
	}

	/**
	 * òֺͼڵλϢ¶λϵͼԪ
	 * @param graph
	 * @param map
	 */
	protected void applyGraphResults(DirectedGraph graph, Map map) {
		for (int i = 0; i < getChildren().size(); i++) {
			NodePart node = (NodePart) getChildren().get(i);
			Node n = (Node) map.get(node);
			node.getFigure().setBounds(new Rectangle(n.x, n.y, n.width, n.height));
		}
	}

	/**
	 * ͼԪNodePartתΪڵ㣨Nodeͼ
	 * @param graph
	 * @param map
	 */
	public void contributeNodesToGraph(DirectedGraph graph, Map map) {
		for (int i = 0; i < getChildren().size(); i++) {
			NodePart node = (NodePart) getChildren().get(i);
			org.eclipse.draw2d.graph.Node n = new org.eclipse.draw2d.graph.Node(node);
			n.width = node.getFigure().getPreferredSize().width;
			n.height = node.getFigure().getPreferredSize().height;
			n.setPadding(new Insets(10, 8, 10, 12));
			map.put(node, n);
			graph.nodes.add(n);
		}
	}

	/**
	 * ӣConnectionPartתΪߣEdgeӵͼ
	 * @param graph
	 * @param map
	 */
	public void contributeEdgesToGraph(DirectedGraph graph, Map map) {
		for (int i = 0; i < getChildren().size(); i++) {
			NodePart node = (NodePart) children.get(i);
			List outgoing = node.getSourceConnections();
			for (int j = 0; j < outgoing.size(); j++) {
				ConnectionPart conn = (ConnectionPart) outgoing.get(j);
				Node source = (Node) map.get(conn.getSource());
				Node target = (Node) map.get(conn.getTarget());
				Edge e = new Edge(conn, source, target);
				e.weight = 2;
				graph.edges.add(e);
				map.put(conn, e);
			}
		}
	}

}